-- debug.lua

local cocluaTable = {
  leiting='/Users/leiting/workspace/cocs/client/scripts',
  guoxiaocuan_8311='/Users/guoxiaocuan_8311/mobilework/cocs/client/scripts',
  AlbertMa='/Users/AlbertMa/Projects/MZBY/Server/cocs/client/scripts',
  evepoe='/Users/evepoe/work/cocs/client/scripts',
  xiaobin='/Users/xiaobin/mobile/cocs/client/scripts',
  wenjie='/Users/wenjie/mobile/cocs/client/scripts',
  yibing='/Users/yibing/mobile/cocs/client/scripts',
  apple='/Users/apple/workspace/cocs/client/scripts', 
  wislylov='/Users/wislylov/workspace/cocs/client/scripts', 
  wenjun='/Users/wenjun/Desktop/cocs/client/scripts',
  JaheiraZhang='/Users/JaheiraZhang/Desktop/cocs/client/scripts',
  firevale='/Users/firevale/Desktop/cocs/client/scripts',
  sinper='/Users/sinper/Desktop/cocs/client/scripts',
  pks='/Users/pks/workspace/cocs/client/scripts', 
  xiaodongwu='/Users/xiaodongwu/workspace/cocs/client/scripts', 
}

local user = os.getenv("USER") or "none"
local folder = nil
local mtable = {}

if PLATFORM == 'android' then
  folder = '/sdcard/scripts'
elseif PLATFORM == 'ios' then
  folder = cocluaTable[user] or "none"
end

local function pollChangedFile(root, mtable)
  for file in lfs.dir(root) do
    local name = tostring(file)
    local fullname = root .. '/' .. name
    if string.find(name, '.', 1, true) ~= 1 then
      local mode = lfs.attributes(fullname, 'mode')
      if mode == 'directory' then
        local changed = pollChangedFile(fullname, mtable)
        if changed then
          return changed
        end
      elseif mode == 'file' then
        local modtime = lfs.attributes(fullname, 'modification')
        local modtime0 = mtable[fullname]
        mtable[fullname] = modtime
        if modtime0 and modtime0 < modtime then
          return fullname
        end
      end
    end
  end
  return nil
end

if type(folder) == 'string' and folder ~= 'none' then
  CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(
    function ()
      local file = pollChangedFile(folder, mtable)
      if file then
        local idx = file:find('scripts/')
        if idx ~= nil then
          local relative = file:sub(idx + 8)
          if relative:sub(-4, -1) == '.lua' then
            local pkg = relative:sub(1, -5):gsub('/', '.')
            print('$$ Reloading: ' .. relative .. '[' .. pkg .. ']')
            package.loaded[pkg] = nil
            dofile(folder .. '/' .. relative)
          end
        end
      end
    end, 1.5, false
  )
end

print('[LUA] ======= DEBUG MODE =======')
print('[LUA] = USER: ' .. user)
print('[LUA] = dev folder: ' .. folder)
print('[LUA] ==========================')

local scripts = folder:sub(1, -8)
package.path = scripts.."/?.lua"

require 'scripts/init'
require 'scripts/base/base'

game.mode = 'development'
game.script = 'debug folder'

if PLATFORM == 'android' then
  game.resourceFolder = '/sdcard/resources'
end

xpcall(__main, __G__TRACKBACK__)
